<template>
  <div :class="classes">
    <div class="input">
      <input
        type="text"
        class="input-field"
        :class="{ '-show-results': showResults }"
        placeholder="Введите номер или наименование запчасти"
        v-model="query"
        @focus="inputFocused = true"
        @blur="inputFocused = false"
        @keyup.enter="search">

      <AppSearchSuggestions
        @mouseover.native="resultsFocused = true"
        @mouseout.native="resultsFocused = false"
        v-show="showResults"
        :suggestions="results">
        <template
          v-if="$scopedSlots && $scopedSlots['suggestion-item']"
          #suggestion-item="{ suggestion }">
          <slot
            name="suggestion-item"
            :suggestion="suggestion" />
        </template>
      </AppSearchSuggestions>

      <slot name="additional-slot"/>

      <AppButton
        @click.native="search"
        :classes="['_cut-left']">
        <template
          v-if="$slots['button-item']"
          #button-item>
          <slot name="button-item"/>
        </template>
        <template
          v-else
          #button-item>
          <img
            svg-inline
            src="~/assets/svg/redesign/magnifer.svg">
          <img
            svg-inline
            src="~/assets/svg/redesign/magnifer-bold.svg">
          <img
            svg-inline
            src="~/assets/svg/redesign/magnifer-home.svg">
          Найти
        </template>
      </AppButton>
    </div>
  </div>
</template>

<script>
import { debounce } from 'lodash-es';
import AppSearchSuggestions from '~/components/redesign/app-search/app-search-suggestions';
import AppButton from '~/components/redesign/app-buttons/app-button';

export default {
  name: 'AppAbstractSearch',
  components: {
    AppSearchSuggestions,
    AppButton,
  },
  props: {
    resultsLoader: {
      type: Function,
      required: true,
    },
    value: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      query: this.value || '',
      results: [],
      resultsLoaded: false,
      resultsFocused: false,
      inputFocused: false,
    };
  },
  computed: {
    showResults() {
      return Boolean(this.query.trim().length)
        && this.resultsLoaded
        && (this.inputFocused || this.resultsFocused);
    },
    classes() {
      const noResults = !(this.results && this.results.length) && this.showResults;
      return {
        appSearch: true,
        '_with-suggestions': this.results && this.results.length,
        '_no-results': noResults,
      };
    },
  },
  watch: {
    value(newValue) {
      this.resultsFocused = false;
      this.query = newValue;
    },
    query(newValue) {
      this.results = [];
      this.resultsLoaded = false;
      this.debouncedGetResults();
      this.$emit('input', newValue);
    },
  },
  created() {
    this.debouncedGetResults = debounce(this.getResults, 200);
  },
  methods: {
    async getResults() {
      this.resultsLoaded = false;

      if (!this.query.trim().length) {
        return false;
      }

      this.results = await this.resultsLoader(this.query)
        .catch(e => console.error(e))
        .finally(() => {
          this.resultsLoaded = true;
        });

      return true;
    },
    search() {
      this.$emit('search', this.query);
    },
  },
};
</script>

<style lang="postcss">
  .appSearch {
    position: relative;
    z-index: 100;
    display: inline-flex;
    justify-content: space-between;
    width: 100%;
    max-width: 45rem;
    transition: visibility .1s var(--transition-easeOutQuad), height .3s var(--transition-easeOutQuad);
    &._on-page {
      margin-top: 1rem;
    }

    .input {
      position: relative;
      width: 100%;

      &-field {
        position: relative;
        z-index: 2;
        padding-right: 4rem;
        background-color: var(--bg-lightener);
        &.-show-results {
          border-bottom-left-radius: 0;
        }
      }

      .button {
        position: absolute;
        z-index: 3;
        top: 0;
        bottom: 0;
        right: 0;
        height: 100%;
        min-width: 4rem;
        font-size: 0;

        .svg {
          width: 1rem;
          height: auto;
          &.magnifier-bold,
          &.magnifier-home {
            display: none;
          }
        }
      }
    }

    &._with-suggestions,
    &._no-results {
      .searchParts-input {
        border-bottom-left-radius: 0;
      }
      .suggestions {
        display: block;
      }
    }
    &._no-results {
      .suggestions-wrapper {
        padding-bottom: 0;
      }
    }

  @media screen and (max-width: 980px) {
      .input {
        max-width: 100vw;
        &-field {
          padding: 1.25rem 4rem  1.25rem 0.875rem;
          height: var(--btn-height-huge);
          font-size: 1rem;
          background-color: transparent;
          box-shadow: none;
        }

        .button {
          position: absolute;
          z-index: 2;
          top: 1px;
          right: 1px;
          bottom: 1px;
          background-color: transparent;

          .svg {
            width: 1.25rem;
            fill: var(--fill-light);
            &.magnifier-bold {
              display: block;
            }
            &.magnifier-thin {
              display: none;
            }
          }
        }
      }
    }
  }
</style>
